require 'rubygems'
require 'net/http'
require 'json'

module EyePea
  class EyePea::Client
    @@DEBUG = false
    @@API = 'http://eyepea.heroku.com/api/1'
    
    # Run her baby
    def self.run!
      puts self.loading_msg
      begin
        ip = self.get_ip
        puts self.success_msg(ip)
      rescue Exception => e
        puts e if @@DEBUG
        puts self.error_msg
      end
    end

    # Make api request to get IP
    def self.get_ip
      result = Net::HTTP.get(URI.parse(@@API+'/ip.json'))
      json_result = JSON.parse(result)

      if json_result.has_key? 'Error'
        raise 'JSON error'
      end

      json_result['ip'].to_s
    end

    # Error when can't find ip
    def self.error_msg
      msgs = [
        'Uh oh! Some unknown error occurred'
      ]
      msgs[rand(msgs.size)]
    end

    def self.success_msg(ip)
      "IP: "+ip.to_s
    end

    # Text loading
    def self.loading_msg
      msgs = [
        'Body massage machine go',
        'Searching the intertubes',
        'Dialing up',
        'Here we go'
      ]
      msgs[rand(msgs.size)] + '..'
    end
  end
end